/* eslint-disable max-params */
/* eslint-disable @typescript-eslint/ban-types */
import assert from 'assert';
import { pager } from './builder.auto-paging.js';
import { builderBindEvents } from './builder.event.js';
import { createBuilderProperties } from './builder.props.js';
import { defaultPropDescriptor } from './config.js';
import { builderApplyTransactingProxy } from './proxy.apply.js';
import { extRefTableFnPropertyAutoPaging } from './proxy.auto-paging.js';
import { createQueryBuilderGetProxy } from './proxy.get.js';
import { proxyGetThen } from './proxy.get.then.js';
import { extRefTableFnPropertySmartJoin } from './smart-join.js';
export function createRefTables(kmore, prefix, caseConvert) {
    const rb = {};
    // @ts-ignore
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
    if (!kmore.dict?.tables || !Object.keys(kmore.dict.tables).length) {
        console.info('Kmore:createRefTables() kmore.dict or kmore.dict.tables empty');
        return rb;
    }
    // @ts-ignore
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
    Object.keys(kmore.dict.tables).forEach((refName) => {
        const name = `${prefix}${refName}`;
        // @ts-expect-error
        const queryBuilderCreator = (options) => {
            const ctx2 = options?.ctx ?? { id: kmore.dbId, instanceId: kmore.instanceId };
            return extRefTableFnProperty(kmore, refName, caseConvert, ctx2, options?.ctxBuilderPreProcessor, options?.ctxBuilderResultPreProcessor, options?.ctxExceptionHandler);
        }; // must dynamically!!
        Object.defineProperty(rb, name, {
            ...defaultPropDescriptor,
            writable: true,
            value: queryBuilderCreator,
        });
        Object.defineProperty(rb[name], 'name', {
            ...defaultPropDescriptor,
            value: name,
        });
    });
    return rb;
}
function extRefTableFnProperty(kmore, refName, caseConvert, ctx, ctxBuilderPreProcessor, ctxBuilderResultPreProcessor, ctxExceptionHandler) {
    assert(caseConvert, 'caseConvert must be defined');
    const kmoreQueryId = Symbol(`${kmore.dbId}-${Date.now().toString()}`);
    // @ts-ignore
    assert(kmore.dbh);
    // @ts-ignore
    // eslint-disable-next-line @typescript-eslint/no-unsafe-call
    let refTable = kmore.dbh(refName);
    // refTable = extRefTableFnPropertyThen(kmore, refTable, ctx) // must before getProxy
    // refTable = createQueryBuilderGetProxy(kmore, refTable)
    refTable = createQueryBuilderGetProxy({
        kmore,
        builder: refTable,
        thenHandler: proxyGetThen,
        ctxBuilderPreProcessor,
        ctxBuilderResultPreProcessor,
        ctxExceptionHandler,
        resultPagerHandler: pager,
    });
    refTable = builderApplyTransactingProxy(kmore, refTable, ctx);
    refTable = extRefTableFnPropertySmartJoin(refTable);
    refTable = builderBindEvents(kmore, refTable, caseConvert, ctx, kmoreQueryId);
    refTable = extRefTableFnPropertyAutoPaging(refTable);
    refTable = createBuilderProperties(refTable, caseConvert, kmoreQueryId, kmore.dict, kmore.dbId);
    return refTable;
}
//# sourceMappingURL=builder.index.js.map