import type { KmoreQueryBuilder } from './builder.types.js';
import { EventCallbacks, OnQueryData, OnQueryErrorData, OnQueryErrorErr, OnQueryRespRaw, QueryResponse } from './types.js';
export interface CallCbOptionsBase<Ctx = any> {
    ctx: Ctx | undefined;
    dbId: string;
    cbs: EventCallbacks<Ctx> | undefined;
    kmoreQueryId: symbol;
}
export interface CallCbOnStartOptions<Ctx = any> extends CallCbOptionsBase<Ctx> {
    builder: KmoreQueryBuilder;
}
export declare function callCbOnStart(options: CallCbOnStartOptions): void;
export interface CallCbOnQueryOptions<Ctx = any> extends CallCbOptionsBase<Ctx> {
    data: OnQueryData;
}
export declare function callCbOnQuery(options: CallCbOnQueryOptions): void;
export interface CallCbOnQueryRespOptions<Ctx = any> extends CallCbOptionsBase<Ctx> {
    _resp: QueryResponse;
    respRaw: OnQueryRespRaw;
}
export declare function callCbOnQueryResp(options: CallCbOnQueryRespOptions): void;
export interface CallCbOnQueryErrorOptions<Ctx = any> extends CallCbOptionsBase<Ctx> {
    err: OnQueryErrorErr;
    data: OnQueryErrorData;
}
export declare function callCbOnQueryError(options: CallCbOnQueryErrorOptions): void | Promise<void>;
//# sourceMappingURL=event.d.ts.map